# coding:utf-8
"""
ebay api include the function detail
"""
import urllib, urllib2
from info_sync.interface.ebay.ebay_api import EBayAPI

# ========= ebay proxy ==============
EBAY_PROXY_URL = 'http://54.89.124.145:8234/marketplaces/ebay_service'

class Ebay:
    def __init__(self, account_info, **params):
        """
        :param account_info:  account info
        """
        self.account_info = account_info
        self.proxy = False
        if 'proxy' in params:
            self.proxy = params['proxy']
        self.proxy_host = EBAY_PROXY_URL
        self._timeout = 90
        self.__api_type = None
        self.__function_name = ''
        self.__call_data = {}
        self.__data = {}

    def execute(self, function_name, calldata):
        self.__api_type = 'trading'
        self.__function_name = function_name
        self.__call_data = calldata
        return self.__make_call()

    def common_execute(self, function_name, **call_data):
        """
        used to run function with call_data
        :param function_name:
        :param call_data:
        :return:
        """
        self.__api_type = 'trading'
        self.__call_data = call_data
        self.__function_name = function_name
        return self.__make_call()

    def __make_call(self):
        """
        call api function
        :return:
        """
        if self.proxy:
            return self.__proxy_make_call()
        ebay = EBayAPI(self.account_info, self.__api_type)
        return ebay.execute_call(self.__function_name, **self.__call_data)

    def common(self, api_type, function_name, **call_data):
        """
        used to run function with call_data
        :param api_type:
        :param function_name:
        :param call_data:
        :return:
        """
        self.__call_data = call_data
        self.__api_type = api_type
        self.__function_name = function_name
        return self.__make_call()

    def __proxy_make_call(self):
        """
        use porxy to call api
        :return:
        """
        self.__del_data()
        try:
            return eval(urllib2.urlopen(self.proxy_host, urllib.urlencode(self.__data), timeout=self._timeout).read())
        except Exception as e:
            print 'Unkown error:', str(e)
            if str(e).find('timed out') != '-1':
                print 'Unkown error: request again'
                try:
                    return eval(urllib2.urlopen(self.proxy_host, urllib.urlencode(self.__data),
                                                timeout=2 * self._timeout).read())
                except Exception as e:
                    return {'result': False, 'message': str(e)}
            else:
                return {'result': False, 'message': str(e)}

    def __del_data(self):
        """
        prepare the params where use proxy call api
        :return:params
        """
        self.__data = {
            'account_info': self.account_info,
            'method': self.__function_name,
            'api_type': self.__api_type,
            'params': self.__call_data
        }

